#
# Table structure for table `clients`
#

DROP TABLE IF EXISTS `clients`;
CREATE TABLE `clients` (
  `num` smallint(4) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `username` varchar(30) NOT NULL default '',
  `email` varchar(100) default NULL,
  `phone` tinytext,
  `contact` varchar(100) default NULL,
  `notes` text,
  `CalView` tinyint(1) NOT NULL default '1',
  `last login` varchar(32) default NULL,
  UNIQUE KEY `employee` (`name`),
  UNIQUE KEY `username` (`username`),
  KEY `num` (`num`)
) TYPE=MyISAM PACK_KEYS=0 AUTO_INCREMENT=0 ;

# --------------------------------------------------------

#
# Table structure for table `cronoemail`
#

DROP TABLE IF EXISTS `cronoemail`;
CREATE TABLE `cronoemail` (
  `id` smallint(6) NOT NULL auto_increment,
  `hours` smallint(6) NOT NULL default '0',
  `email` mediumtext NOT NULL,
  `sub` text NOT NULL,
  `message` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=0 ;

# --------------------------------------------------------

#
# Table structure for table `employee labor`
#

DROP TABLE IF EXISTS `employee labor`;
CREATE TABLE `employee labor` (
  `employee` tinyint(6) NOT NULL default '0',
  `labor type` tinyint(4) NOT NULL default '0'
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Table structure for table `employees`
#

DROP TABLE IF EXISTS `employees`;
CREATE TABLE `employees` (
  `num` smallint(4) NOT NULL auto_increment,
  `employee` varchar(100) NOT NULL default '',
  `active` tinyint(1) NOT NULL default '1',
  `username` varchar(30) NOT NULL default '',
  `email` varchar(100) default NULL,
  `email2` varchar(100) default NULL,
  `notifydays` tinyint(3) NOT NULL default '0',
  `notifyemail` tinyint(1) NOT NULL default '1',
  `remindemail` tinyint(1) NOT NULL default '1',
  `laborer` tinyint(1) NOT NULL default '1',
  `lightingdesigner` tinyint(1) NOT NULL default '0',
  `engineer` tinyint(1) NOT NULL default '0',
  `gigchief` tinyint(1) NOT NULL default '0',
  `dj` tinyint(1) NOT NULL default '0',
  `phone` tinytext,
  `isAdmin` tinyint(1) NOT NULL default '0',
  `CalView` tinyint(1) NOT NULL default '1',
  `notes` tinytext,
  `commission` tinyint(3) NOT NULL default '0',
  `last login` varchar(32) default NULL,
  UNIQUE KEY `username` (`username`),
  UNIQUE KEY `employee` (`employee`),
  KEY `num` (`num`)
) TYPE=MyISAM AUTO_INCREMENT=0 ;

# --------------------------------------------------------

#
# Table structure for table `gear2`
#

DROP TABLE IF EXISTS `gear2`;
CREATE TABLE `gear2` (
  `date` double NOT NULL default '0',
  `item` tinyint(4) NOT NULL default '0',
  `qty` tinyint(4) NOT NULL default '0',
  `use_acc` tinyint(1) NOT NULL default '0',
  `use_acc2` tinyint(1) NOT NULL default '0',
  `rent_qty` tinyint(4) NOT NULL default '0',
  `rent_co` tinytext
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Table structure for table `gear_presets`
#

DROP TABLE IF EXISTS `gear_presets`;
CREATE TABLE `gear_presets` (
  `preset` tinyint(4) NOT NULL default '0',
  `item` tinyint(4) NOT NULL default '0',
  `qty` tinyint(4) NOT NULL default '0',
  `use_acc` tinyint(1) NOT NULL default '0',
  `use_acc2` tinyint(1) NOT NULL default '0'
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Table structure for table `gig labor needs`
#

DROP TABLE IF EXISTS `gig labor needs`;
CREATE TABLE `gig labor needs` (
  `date` decimal(10,2) NOT NULL default '0.00',
  `labor type` tinyint(4) NOT NULL default '0',
  `needed` tinyint(4) NOT NULL default '0'
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Table structure for table `gig labor`
#

DROP TABLE IF EXISTS `gig labor`;
CREATE TABLE `gig labor` (
  `date` decimal(10,2) NOT NULL default '0.00',
  `labor type` tinyint(4) NOT NULL default '0',
  `employee` tinyint(6) NOT NULL default '0',
  `pay` decimal(6,2) NOT NULL default '0.00',
  `check` tinyint(1) NOT NULL default '0',
  `cash` tinyint(1) NOT NULL default '0',
  `payref` varchar(25) default NULL,
  `active` tinyint(1) NOT NULL default '1'
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Table structure for table `gig types`
#

DROP TABLE IF EXISTS `gig types`;
CREATE TABLE `gig types` (
  `num` tinyint(3) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `color` varchar(6) NOT NULL default '',
  PRIMARY KEY  (`num`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM PACK_KEYS=0 AUTO_INCREMENT=0 ;

# --------------------------------------------------------

#
# Table structure for table `gigs`
#

DROP TABLE IF EXISTS `gigs`;
CREATE TABLE `gigs` (
  `date` decimal(10,2) NOT NULL default '0.00',
  `type` tinyint(2) NOT NULL default '0',
  `desc` text NOT NULL,
  `fee` decimal(5,2) NOT NULL default '0.00',
  `notes` text NOT NULL,
  `active` tinyint(1) NOT NULL default '1',
  `time` tinytext NOT NULL,
  `lastmod` smallint(10) default NULL,
  `rent` tinytext,
  `payrent` decimal(6,2) NOT NULL default '0.00',
  `downpayment` decimal(5,2) default NULL,
  `whobooked` varchar(100) NOT NULL default 'devine',
  `commissionvalue` decimal(5,2) NOT NULL default '0.00',
  `commissionname` varchar(100) default NULL,
  `commissionpaid` tinyint(2) NOT NULL default '0',
  `miles` int(11) NOT NULL default '0',
  `files` text,
  `clients_email` tinytext,
  `client` tinyint(4) default NULL,
  `departure_time` tinytext,
  `setup_time` tinytext,
  `payment_received` tinyint(1) NOT NULL default '0',
  `pending` tinyint(1) NOT NULL default '0',
  UNIQUE KEY `date` (`date`),
  KEY `date_2` (`date`)
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Table structure for table `inventory-bak`
#

DROP TABLE IF EXISTS `inventory-bak`;
CREATE TABLE `inventory-bak` (
  `ITEM` smallint(6) NOT NULL auto_increment,
  `NAME` char(40) NOT NULL default '',
  `QTY` smallint(4) NOT NULL default '0',
  `ACC` smallint(4) default NULL,
  `ACC2` smallint(4) default NULL,
  `Serialized` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`ITEM`)
) TYPE=MyISAM AUTO_INCREMENT=0 ;

# --------------------------------------------------------

#
# Table structure for table `inventory`
#

DROP TABLE IF EXISTS `inventory`;
CREATE TABLE `inventory` (
  `ITEM` smallint(6) NOT NULL auto_increment,
  `NAME` char(40) NOT NULL default '',
  `QTY` smallint(4) NOT NULL default '0',
  `ACC` smallint(4) default NULL,
  `ACC2` smallint(4) default NULL,
  `Serialized` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`ITEM`)
) TYPE=MyISAM AUTO_INCREMENT=0 ;

# --------------------------------------------------------

#
# Table structure for table `labor types`
#

DROP TABLE IF EXISTS `labor types`;
CREATE TABLE `labor types` (
  `num` tinyint(4) NOT NULL auto_increment,
  `name` varchar(40) NOT NULL default '',
  `ABR` varchar(4) NOT NULL default '',
  PRIMARY KEY  (`num`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM AUTO_INCREMENT=0 ;

# --------------------------------------------------------

#
# Table structure for table `preset_names`
#

DROP TABLE IF EXISTS `preset_names`;
CREATE TABLE `preset_names` (
  `NUM` tinyint(4) NOT NULL auto_increment,
  `NAME` char(60) NOT NULL default '',
  UNIQUE KEY `NAME` (`NAME`),
  KEY `NUM` (`NUM`)
) TYPE=MyISAM AUTO_INCREMENT=0 ;

# --------------------------------------------------------

#
# Table structure for table `serial inventory`
#

DROP TABLE IF EXISTS `serial inventory`;
CREATE TABLE `serial inventory` (
  `num` smallint(6) NOT NULL default '0',
  `serial` varchar(30) NOT NULL default '',
  `notes` text,
  `date purchased` varchar(10) default NULL,
  `value` double(10,2) NOT NULL default '0.00',
  UNIQUE KEY `serial` (`serial`)
) TYPE=MyISAM;




# --------------------------------------------------------

#
# Table structure for table `color preset 1`
#

CREATE TABLE `color preset 1` (
  `num` tinyint(4) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `color` varchar(30) default NULL,
  PRIMARY KEY  (`num`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM PACK_KEYS=0;

#
# Dumping data for table `color preset 1`
#

INSERT INTO `color preset 1` VALUES (1, 'background', 'FFFF66');
INSERT INTO `color preset 1` VALUES (2, 'default font', '000000');
INSERT INTO `color preset 1` VALUES (3, 'table background', '339933');
INSERT INTO `color preset 1` VALUES (4, 'table bordercolor', 'FF3300');
INSERT INTO `color preset 1` VALUES (5, 'calendar background', 'FFFFFF');
INSERT INTO `color preset 1` VALUES (6, 'calendar today', 'CCFF99');
INSERT INTO `color preset 1` VALUES (7, 'labor full highlight', 'FFFF00');
INSERT INTO `color preset 1` VALUES (8, 'signup ok highlight', '66CC66');
INSERT INTO `color preset 1` VALUES (9, 'delinquent font', 'FF0000');
INSERT INTO `color preset 1` VALUES (10, 'error font', 'FF00CC');

# --------------------------------------------------------

#
# Table structure for table `color preset 2`
#

CREATE TABLE `color preset 2` (
  `num` tinyint(4) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `color` varchar(30) default NULL,
  PRIMARY KEY  (`num`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM PACK_KEYS=0;

#
# Dumping data for table `color preset 2`
#

INSERT INTO `color preset 2` VALUES (1, 'background', '000000');
INSERT INTO `color preset 2` VALUES (2, 'default font', 'CCCCCC');
INSERT INTO `color preset 2` VALUES (3, 'table background', '333333');
INSERT INTO `color preset 2` VALUES (4, 'table bordercolor', '993300');
INSERT INTO `color preset 2` VALUES (5, 'calendar background', 'FFFFFF');
INSERT INTO `color preset 2` VALUES (6, 'calendar today', 'FF3300');
INSERT INTO `color preset 2` VALUES (7, 'labor full highlight', 'CCFFCC');
INSERT INTO `color preset 2` VALUES (8, 'signup ok highlight', '66CC66');
INSERT INTO `color preset 2` VALUES (9, 'delinquent font', 'FFFFFF');
INSERT INTO `color preset 2` VALUES (10, 'error font', '990000');

# --------------------------------------------------------

#
# Table structure for table `color preset 3`
#

CREATE TABLE `color preset 3` (
  `num` tinyint(4) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `color` varchar(30) default NULL,
  PRIMARY KEY  (`num`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM PACK_KEYS=0;

#
# Dumping data for table `color preset 3`
#

INSERT INTO `color preset 3` VALUES (1, 'background', 'FFFFFF');
INSERT INTO `color preset 3` VALUES (2, 'default font', '000000');
INSERT INTO `color preset 3` VALUES (3, 'table background', '99ccff');
INSERT INTO `color preset 3` VALUES (4, 'table bordercolor', 'FFFFFF');
INSERT INTO `color preset 3` VALUES (5, 'calendar background', 'FFFFFF');
INSERT INTO `color preset 3` VALUES (6, 'calendar today', 'FFFFCC');
INSERT INTO `color preset 3` VALUES (7, 'labor full highlight', '99CCFF');
INSERT INTO `color preset 3` VALUES (8, 'signup ok highlight', '00FF00');
INSERT INTO `color preset 3` VALUES (9, 'delinquent font', 'FF0000');
INSERT INTO `color preset 3` VALUES (10, 'error font', 'FF0000');

# --------------------------------------------------------

#
# Table structure for table `color setup`
#

CREATE TABLE `color setup` (
  `num` tinyint(4) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `color` varchar(30) default NULL,
  PRIMARY KEY  (`num`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM PACK_KEYS=0;

#
# Dumping data for table `color setup`
#

INSERT INTO `color setup` VALUES (1, 'background', '000000');
INSERT INTO `color setup` VALUES (2, 'default font', 'CCCCCC');
INSERT INTO `color setup` VALUES (3, 'table background', '333333');
INSERT INTO `color setup` VALUES (4, 'table bordercolor', '993300');
INSERT INTO `color setup` VALUES (5, 'calendar background', 'FFFFFF');
INSERT INTO `color setup` VALUES (6, 'calendar today', 'FF3300');
INSERT INTO `color setup` VALUES (7, 'labor full highlight', 'CCFFCC');
INSERT INTO `color setup` VALUES (8, 'signup ok highlight', '66CC66');
INSERT INTO `color setup` VALUES (9, 'delinquent font', 'FFFFFF');
INSERT INTO `color setup` VALUES (10, 'error font', '990000');

# --------------------------------------------------------

#
# Table structure for table `setup`
#

DROP TABLE IF EXISTS `setup`;
CREATE TABLE `setup` (
  `name` char(30) NOT NULL default '',
  `value` char(128) default NULL,
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM;

#
# Dumping data for table `setup`
#
  
INSERT INTO `setup` VALUES ('Company Name', 'My Company');
INSERT INTO `setup` VALUES ('Shipping Address', '123 Easy Street');
INSERT INTO `setup` VALUES ('Shipping City', 'Anytown');
INSERT INTO `setup` VALUES ('Shipping State', 'Anystate');
INSERT INTO `setup` VALUES ('Shipping Zip', '12345');
INSERT INTO `setup` VALUES ('Phone Number', '(555) 555-5555');
INSERT INTO `setup` VALUES ('Email Address', 'anyone@anydomain.com');
INSERT INTO `setup` VALUES ('Link At Top', 'http://anydomain.com');
INSERT INTO `setup` VALUES ('Link At Top Name', 'Back to our Website');
INSERT INTO `setup` VALUES ('Domain Name', 'anydomain.com');
INSERT INTO `setup` VALUES ('Mail Server', 'mail.anydomain.com');
INSERT INTO `setup` VALUES ('Upload Directory', '/var/www/html/files');
INSERT INTO `setup` VALUES ('Upload File URL', 'http://anydomain.com/files/');
INSERT INTO `setup` VALUES ('Master User', 'admin');
INSERT INTO `setup` VALUES ('Presidents Name', 'John Doe');
INSERT INTO `setup` VALUES ('Edit Path', '/path/to/cgi-bin/edit');
INSERT INTO `setup` VALUES ('Employee Path', '/path/to/cgi-bin/employee');
INSERT INTO `setup` VALUES ('Company Slogan', 'Company Slogan Here');
INSERT INTO `setup` VALUES ('Company Logo', '');
INSERT INTO `setup` VALUES ('Signup Confirm Message', 'Are you sure you are going to do a good job if you work this event?');
