#!/usr/bin/perl

###################################################
#### 	  developed by: Nason Tackett          ####
####             nason@nason.com               ####
###################################################

sub WARN_handler {		## Redefine PERL's warn & die handelers to print any errors to the screen
    	my($signal) = @_;
    	print "<font size=4 color=\"$COLORSETUP{'error font'}\">ERROR: $signal</font><br>\n";	
}

$SIG{__DIE__} = 'WARN_handler';
$SIG{__WARN__} = 'WARN_handler';


read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/~!/ ~!/g;
    $value =~ s/"/\&quot\;/g;
    $value =~ s/'/\'/g;   
    $FORM{$name} = $value;
}



## Make and array out of the query string
@strings = split(/&/, $ENV{'QUERY_STRING'});
foreach $string (@strings) {
        $string =~ s/%20/ /i;
        $string =~ s/\+/ /ig;
        $string =~ s/\%7C/\|/ig;
        $string =~ s/\%24/\$/ig;
        $string =~ s/\%0A//ig;
        $string =~ s/\%2F/\//ig;
        $string =~ s/\%26/\&/ig;
        $string =~ s/\%27/'/ig;
        $string =~ s/\%28/(/ig;
        $string =~ s/\%29/)/ig;
        ($name,$value) = split(/=/,$string);
        $FORM{$name} = $value;
}

use DBI();
require "../db.cfg";       ## Database Connection

if ($ENV{'REMOTE_USER'} ne "") {
        $username = $ENV{'REMOTE_USER'};
} elsif ($FORM{'username'} ne "") {
        $username = $FORM{'username'};
} else {
        $message = "Unable to log you in... This could be caused by the directory password protection not functioning properly.\n";
        &panic;
        $dbh->disconnect();
        exit;
}


if ($FORM{'editregistration'}) {
	&updateregistration;
}

$schedulen = `./schedulen`;
$schedulen =~ s/\n//ig;   
if ($schedulen ne "0" && $schedulen ne "-1") {
        $message = "$schedulen\n";
        &panic;
	&showreg;
        $dbh->disconnect();
        exit;
}

require "gear.inc";
require "client.inc";
require "employee.inc";
require "gig.inc";
require "email.inc";
require "setup.inc";
require "invoice.inc";

print "Content-type:text/html\n\n";

if ($FORM{'loadcolorpreset'}) {
	&loadcolorpreset;
	&refreshsetup;
	&header;
        &setup; 
        &credit;
        $dbh->disconnect();
        exit;
} elsif ($FORM{'editsetup'}) {
	&refreshsetup;
        &editsetup;
	&refreshsetup;
	&header;
	&setup;
	&credit;
        $dbh->disconnect(); 
        exit;
} elsif ($FORM{'newlabortype'}) {
        &newlabortype;
        &refreshsetup;
	&header;
        &setup;
	&credit;
        $dbh->disconnect();
        exit;
} elsif ($FORM{'neweventtype'}) {
        &neweventtype;
	&refreshsetup;
	&header;
        &setup;
	&credit;
        $dbh->disconnect();
        exit;
} else {
	&refreshsetup;
}

@DAYS = ("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");
@month = ("", "Jan", "Feb", "March", "April", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec");


$DBI::result = $dbh->prepare("select * from `employees` WHERE `username` = \"$username\"");
$DBI::result->execute();

while(@row = $DBI::result->fetchrow_array) {
        $realname = $row[1];
        $employeenum = $row[0];
        $active = $row[2];
        $isAdmin = $row[15];
        $CalView = $row[16];
	$lastlogin = $row[19];
}


foreach $key (%FORM) {
        if ($FORM{$key} eq "View Invoice" && !$FORM{'MS'}) {
                $edit = $key;
		if ($FORM{'multipleinvoice'}) {
			$mstype="View Invoice";
			&selectmultiplegigs;
			exit;
		} else {
                	&makeinvoice;
			print $invoice;
			exit;
		}
	}
}

unless ($FORM{'mstype'} eq "View Invoice") {
	&header;
}

if ($ENV{'HTTP_REFERER'} !~ /edit.cgi/) {
	$datestamp = `date`;
	$datestamp =~ s/\n//ig;
	$dbh->do("UPDATE `employees` SET `last login` = \"$datestamp\" WHERE `num` = \"$employeenum\"");
	print "<center><b>Last Login: $lastlogin</b></center><br>\n";
}

$FORM{'notes'} =~ s/\\n/\<br\>/ig;

foreach $key (%FORM) {
	if ($FORM{$key} eq "Delete") {
		$delete = $key;
		&delete;
		goto below;
        } elsif ($FORM{$key} eq "Delete Attachment") {
	        $active = $FORM{'active'};
	        $edit = $FORM{'date'};
	        $date = $edit;
		$delete = $key;
	        &deletefile;
	        &edit;
		&credit;
	        $dbh->disconnect();
	        exit;
        } elsif ($FORM{$key} eq "Delete Labor Type") {
		$delete = $key;
                &deletelabortype;
        	&refreshsetup;
        	&setup;
		&credit;
                $dbh->disconnect();
                exit;
        } elsif ($FORM{$key} eq "Delete Event Type") {
		$delete = $key;
                &deleteeventtype;
                &refreshsetup;   
                &setup;
		&credit;
                $dbh->disconnect();
                exit;
        } elsif ($FORM{$key} eq "Delete Item") {
                $delete = $key;
                &deleteinventory;
		&editinventory;
		&credit;
	        $dbh->disconnect();
        	exit;
	} elsif ($FORM{$key} eq "Done") {
		$edit = $key;
		$finish = "true";
		&edit;
		&credit;
		$dbh->disconnect();
		exit;
	} elsif ($FORM{$key} eq "Finish" && !$done) {
		$done = $key;
		$active = 0;
		&update;
		goto below;
	} elsif ($FORM{$key} eq "Undo") {
		$done = $key;
		$active = 1;
		&undo;
		goto below;
        } elsif ($FORM{$key} eq "Approve") {
                $edit = $key;
		&approve;
		&edit;
		&credit;
		$dbh->disconnect();
		exit;
        } elsif ($FORM{$key} eq "MS") {
		push (@selectedgigs, $key);		
        } elsif ($FORM{$key} eq "Send Invoice" && !$FORM{'MS'}) {
                $edit = $key;
                if ($FORM{'multipleinvoice'}) {
			$mstype="Send Invoice";
                        &selectmultiplegigs;
			&credit;
			$dbh->disconnect();
			exit;
                } else {
                	&makeinvoice;
                	&sendinvoice;
			&edit;
			&credit;
			$dbh->disconnect();
			exit;
		}
	} elsif ($FORM{$key} eq "Edit" || $FORM{$key} eq "Ok") {
		$edit = $key;
		if ($FORM{'uploadsucess'} eq 1) {
			$date = $key;
		        $changed = "<font color=red><b><u>Items Modified</u></b><br><li>File Attachment Uploaded<br>\n";
        		$changedtrue=1;
		        &updatenotify;
		}
		&edit;
		&credit;
		$dbh->disconnect();
		exit;
	} elsif ($FORM{$key} eq "Change Employee") {
		$edit = $key;
		&editemployee;
		&employee;
		&credit;
		$dbh->disconnect();
		exit;
        } elsif ($FORM{$key} eq "Change Client") {
                $edit = $key;
                &editclient;
                &client;
		&credit;
                $dbh->disconnect();
                exit;
        } elsif ($FORM{$key} eq "Reset Client Password") {
                $edit = $key;
		$resetpassword = 1;
                &editclient;  
                &client;
		&credit;
                $dbh->disconnect();
                exit;
        } elsif ($FORM{$key} eq "Reset Password") {
                $edit = $key;
                $resetpassword = 1;
                &editemployee;
                &employee;
		&credit;
                $dbh->disconnect();
                exit;
        } elsif ($FORM{$key} eq "Edit Serial Numbers") {
                $itemnum = $key;
                &editserialized;
		&credit;   
                $dbh->disconnect();      
                exit;
        } elsif ($FORM{$key} eq "Delete Serial Item") {
                $itemnum = $FORM{'itemnum'};
		$delete = $key;
		&deleteserial;
                &editserialized;
		&credit;
                $dbh->disconnect();
                exit;
	} 
}

if ($FORM{'new'}) {
	&new;
	if ($FORM{'preset'} ne "") {
		&loadpreset;
	}
	if ($FORM{'gear'}) {
		$new=1;
		&editgear;
		&credit;
	        $dbh->disconnect();
	        exit;
	}
} elsif ($FORM{'MS'}) {
	$edit = $FORM{'edit'};
	if ($FORM{'mstype'} eq "Send Invoice") {
		&makeinvoice;
		&sendinvoice;
		&edit;
		&credit;
		exit;
	}
        if ($FORM{'mstype'} eq "View Invoice") {
		&makeinvoice;
		print $invoice;
		exit;
	}
} elsif ($FORM{'addlink'}) {
        $active = $FORM{'active'};
	$edit = $FORM{'date'};
	$date = $edit;
	&addlink;
        $changed = "<font color=red><b><u>Items Modified</u></b><br><li>File Attachment Uploaded<br>\n";
        $changedtrue=1;
        &updatenotify;	
        &edit;
	&credit;
        $dbh->disconnect();
        exit;   
} elsif ($FORM{'edited'}) {
	$active = $FORM{'active'};
	&update;
	goto below;
} elsif ($FORM{'editemployees'}) {
	&employee;
	&credit;
	$dbh->disconnect();
	exit;
} elsif ($FORM{'updategear'}) {
	$date = $FORM{'date'};
	&updategear;
	&editgear;
	&credit;
	$dbh->disconnect();
	exit;
} elsif ($FORM{'updategearandreturn'}) {
	$showpenis=1;
	$date = $FORM{'date'};
	&updategear;
        $changed = "<font color=red><b><u>Items Modified</u></b><br><li>Equipment List<br>\n";
        $changedtrue=1;
	&updatenotify;
	if ($dontshowrest) {
		&credit;
		exit;
		$dbh->disconnect();
	} else {
		goto below;
	}		
} elsif ($FORM{'showgear'}) {
	$active = $FORM{'active'};
	&update;
	$date = $FORM{'date'};
	&editgear;
	&credit;
	$dbh->disconnect();
	exit;
} elsif ($FORM{'switchdate'}) {
        &editgear;
	&credit;
        $dbh->disconnect();
        exit;
} elsif ($FORM{'setup'}) {
        &setup;
	&credit;
        $dbh->disconnect();
        exit;
} elsif ($FORM{'editclient'}) {
        &client;
	&credit;   
        $dbh->disconnect();
        exit;
} elsif ($FORM{'newclient'}) {
        &addclient;
	&client;
	&credit;
        $dbh->disconnect();  
        exit;
} elsif ($FORM{'editinventory'}) {
        &editinventory;
	&credit;
	$dbh->disconnect();
        exit;
} elsif ($FORM{'updateinventory'}) {
	&updateinventory;
        &editinventory;
	&credit;
        $dbh->disconnect();  
        exit;
} elsif ($FORM{'addinventory'}) {
        &addinventory;
        &editinventory;
	&credit;
	$dbh->disconnect();
        exit;
} elsif ($FORM{'storepreset'}) {     
        $date = $FORM{'date'};
        &updategear;
	&savepreset;
        &editgear;
	&credit;
        $dbh->disconnect();
        exit;
} elsif ($FORM{'loadpreset'}) {
        $date = $FORM{'date'};
        &loadpreset;
        &editgear;
	&credit;
        $dbh->disconnect();
        exit;   
} elsif ($FORM{'overwritepreset'}) {
        $date = $FORM{'date'};
	&updategear;
        &deletepreset;
        &savepreset;
        &editgear;
	&credit;
        $dbh->disconnect();
        exit;   
} elsif ($FORM{'deletepreset'}) {
        $date = $FORM{'date'};
        &updategear;
        &deletepreset;
        &editgear;
	&credit;
        $dbh->disconnect();
        exit;   
} elsif ($FORM{'newemployee'}) {
	&addemployee;
	&employee;
	&credit;
	$dbh->disconnect();
	exit;
} elsif ($FORM{'addserial'}) {
        &addserial;
	$itemnum = $FORM{'itemnum'};
	&editserialized;
	&credit;
        $dbh->disconnect();
        exit;
} elsif ($FORM{'updateserial'}) {
	$itemnum = $FORM{'itemnum'};
        &updateserial;
        &editserialized;
	&credit;
        $dbh->disconnect();
        exit;
}

below:

&getpresets;
&getclients;

if ($FORM{'prevmonth'}) {
	if ($FORM{'browsemonth'} eq "1" || $FORM{'browsemonth'} eq "01") {
		$FORM{'browseyear'}--;
		$FORM{'browsemonth'}=12;
	} else {
		$FORM{'browsemonth'}--;
	}
}

if ($FORM{'nextmonth'}) {
        if ($FORM{'browsemonth'} eq "12") {
                $FORM{'browseyear'}++;
                $FORM{'browsemonth'}=1;
        } else {
                $FORM{'browsemonth'}++;
        }
}

if ($FORM{'calendarview'}) {
        $dbh->do("UPDATE `employees` SET `CalView` = \"1\" WHERE `num` = \"$employeenum\"");
        $CalView=1;
}

if ($FORM{'listview'}) {
        $dbh->do("UPDATE `employees` SET `CalView` = \"0\" WHERE `num` = \"$employeenum\"");
        $CalView=0;
}

print "<FORM METHOD=\"POST\" name=\"top\" id=\"top\" ACTION=\"edit.cgi\">\n";
print "<input type=\"hidden\" name=\"username\" value=\"$username\">\n";

&getemployee;
&print_oweemployees;
&print_delinquent;

if ($CalView  eq "1") {
	if ($FORM{'browseyear'} ne "") {
		$browseyear = $FORM{'browseyear'};
	} else {
		$browseyear = `date +%Y`;
		$browseyear =~ s/\n//ig;
	}
	if ($FORM{'browsemonth'} ne "") {
		$browsemonth = $FORM{'browsemonth'};
	} else {
		$browsemonth = `date +%m`;
		$browsemonth =~ s/\n//ig;
	}
	$title = "$month[$browsemonth], $browseyear";
        $begmon = ($browseyear * 10000) + ($browsemonth * 100);
        $endmon = $begmon + 100;
        $DBI::result = $dbh->prepare("select * from `gigs` WHERE `date` >= \"$begmon\" AND `date` < \"$endmon\" ORDER BY `date` ASC");
        $DBI::result->execute();
} else {
	if ($FORM{'showhist'}) {
		if (length($FORM{'fromyear'}) eq "4" && length($FORM{'frommonth'}) eq "2" && length($FORM{'fromday'}) eq "2" && length($FORM{'toyear'}) eq "4" && length($FORM{'tomonth'}) eq "2" && length($FORM{'today'}) eq "2") {
			$title = "Showing events from $FORM{'frommonth'}/$FORM{'fromday'}/$FORM{'fromyear'} to $FORM{'tomonth'}/$FORM{'today'}/$FORM{'toyear'}";
			$d = "Undo";
			$hisyear = $FORM{'hisyear'} * 10000;
			$ltyear = $hisyear + 10000;
			if ($FORM{'showactive'} eq "1" && $FORM{'showinactive'} eq "1") {
				$COMMISSIONSQL = "select * from `gigs` WHERE `commissionvalue`>0 AND `date` >= \"$FORM{'fromyear'}$FORM{'frommonth'}$FORM{'fromday'}\" AND `date` < \"$FORM{'toyear'}$FORM{'tomonth'}$FORM{'today'}\" ORDER BY `date` DESC";
				$DBI::result = $dbh->prepare("select * from `gigs` WHERE `date` >= \"$FORM{'fromyear'}$FORM{'frommonth'}$FORM{'fromday'}\" AND `date` < \"$FORM{'toyear'}$FORM{'tomonth'}$FORM{'today'}\" ORDER BY `date` DESC");
				$DBI::result->execute();
			} elsif ($FORM{'showactive'} eq "1" && $FORM{'showinactive'} eq "") {
				$COMMISSIONSQL = "select * from `gigs` WHERE `commissionvalue`>0 AND `active`='1' AND `date` >= \"$FORM{'fromyear'}$FORM{'frommonth'}$FORM{'fromday'}\" AND `date` < \"$FORM{'toyear'}$FORM{'tomonth'}$FORM{'today'}\" ORDER BY `date` DESC";
				$DBI::result = $dbh->prepare("select * from `gigs` WHERE `active`='1' AND `date` >= \"$FORM{'fromyear'}$FORM{'frommonth'}$FORM{'fromday'}\" AND `date` < \"$FORM{'toyear'}$FORM{'tomonth'}$FORM{'today'}\" ORDER BY `date` DESC");
				$DBI::result->execute();
			} elsif ($FORM{'showactive'} eq "" && $FORM{'showinactive'} eq "1") {
				$COMMISSIONSQL = "select * from `gigs` WHERE `commissionvalue`>0 AND `active`='0' AND `date` >= \"$FORM{'fromyear'}$FORM{'frommonth'}$FORM{'fromday'}\" AND `date` < \"$FORM{'toyear'}$FORM{'tomonth'}$FORM{'today'}\" ORDER BY `date` DESC";
				$DBI::result = $dbh->prepare("select * from `gigs` WHERE `active`='0' AND `date` >= \"$FORM{'fromyear'}$FORM{'frommonth'}$FORM{'fromday'}\" AND `date` < \"$FORM{'toyear'}$FORM{'tomonth'}$FORM{'today'}\" ORDER BY `date` DESC");
				$DBI::result->execute();
			} else {
				$title = "You have to select either \"Show Active\" or \"Show Inactive\" or both!";
			}	
		} else {
			$title = "You did not enter a date range in the format MM/DD/YYYY, showing All Past History";
			$d = "Undo";
		        $DBI::result = $dbh->prepare("select * from `gigs` WHERE `active`='0' ORDER BY `date` DESC");
		        $DBI::result->execute();
		}
	} else {
		$title = "Current Dates";	
		$d = "Done";
		$DBI::result = $dbh->prepare("select * from `gigs` WHERE `active`='1' ORDER BY `date` ASC");
		$DBI::result->execute();
	}
}

open(HEAD,"popup.html");
@HEAD = <HEAD>;
close HEAD;
foreach $line (@HEAD) {
	print $line;
}


open(HEAD,"combo.html");
@HEAD = <HEAD>;
close HEAD;
foreach $line (@HEAD) {
        print $line;
}

$numclients = keys %CLIENT_EMAIL;

print <<EOT;
	<script LANGUAGE="JavaScript">
	<!--
	function changeEmail()
	{
		var emails = new Array($numclients);
		var clients = new Array($numclients);
		var phones = new Array($numclients);
EOT
	foreach $key (keys(%CLIENT_EMAIL)) {
		print "		emails[$key]='$CLIENT_EMAIL{$key}'\;\n";
		print "		clients[$key]='$CLIENT_NAME{$key}'\;\n";
		print "	        phones[$key]=\"$CLIENT_PHONE{$key}\"\;\n";
	}
	print "	document.top.clientname.value=clients[document.top.client.value];\n";
	print "	document.top.clientsemail.value=emails[document.top.client.value];\n";
	print "	document.top.clientsphone.value=phones[document.top.client.value];\n";
	print "}\n";
print <<EOT;
	// -->
	</script>
<script language = "Javascript">
/**
 * DHTML date validation script. Courtesy of SmartWebby.com (http://www.smartwebby.com/dhtml/)
 */
// Declaring valid date character, minimum year and maximum year
var dtCh= "/";
var minYear=1900;
var maxYear=2100;

function isInteger(s){
	var i;
    for (i = 0; i < s.length; i++){   
        // Check that current character is number.
        var c = s.charAt(i);
        if (((c < "0") || (c > "9"))) return false;
    }
    // All characters are numbers.
    return true;
}

function stripCharsInBag(s, bag){
	var i;
    var returnString = "";
    // Search through string's characters one by one.
    // If character is not in bag, append to returnString.
    for (i = 0; i < s.length; i++){   
        var c = s.charAt(i);
        if (bag.indexOf(c) == -1) returnString += c;
    }
    return returnString;
}

function daysInFebruary (year){
	// February has 29 days in any year evenly divisible by four,
    // EXCEPT for centurial years which are not also divisible by 400.
    return (((year % 4 == 0) && ( (!(year % 100 == 0)) || (year % 400 == 0))) ? 29 : 28 );
}
function DaysArray(n) {
	for (var i = 1; i <= n; i++) {
		this[i] = 31
		if (i==4 || i==6 || i==9 || i==11) {this[i] = 30}
		if (i==2) {this[i] = 29}
   } 
   return this
}

function isDate(dtStr){
	var daysInMonth = DaysArray(12)
	var pos1=dtStr.indexOf(dtCh)
	var pos2=dtStr.indexOf(dtCh,pos1+1)
	var strMonth=dtStr.substring(0,pos1)
	var strDay=dtStr.substring(pos1+1,pos2)
	var strYear=dtStr.substring(pos2+1)
	strYr=strYear
	if (strDay.charAt(0)=="0" && strDay.length>1) strDay=strDay.substring(1)
	if (strMonth.charAt(0)=="0" && strMonth.length>1) strMonth=strMonth.substring(1)
	for (var i = 1; i <= 3; i++) {
		if (strYr.charAt(0)=="0" && strYr.length>1) strYr=strYr.substring(1)
	}
	month=parseInt(strMonth)
	day=parseInt(strDay)
	year=parseInt(strYr)
	if (pos1==-1 || pos2==-1){
		alert("The date format should be : mm/dd/yyyy")
		document.top.month.focus()
		return false
	}
	if (strMonth.length<1 || month<1 || month>12){
		alert("Please enter a valid month")
		document.top.month.focus()
		return false
	}
	if (strDay.length<1 || day<1 || day>31 || (month==2 && day>daysInFebruary(year)) || day > daysInMonth[month]){
		alert("Please enter a valid day")
		document.top.day.focus()
		return false
	}
	if (strYear.length != 4 || year==0 || year<minYear || year>maxYear){
		alert("Please enter a valid 4 digit year between "+minYear+" and "+maxYear)
		document.top.year.focus()
		return false
	}
	if (dtStr.indexOf(dtCh,pos2+1)!=-1 || isInteger(stripCharsInBag(dtStr, dtCh))==false){
		alert("Please enter a valid date")
		document.top.month.focus()
		return false
	}
return true
}

function ValidateForm(){
	var dt=document.top.month.value + '/' + document.top.day.value + '/' + document.top.year.value
	if (isDate(dt)==false){
//		document.top.month.focus()
		return false
	}
    return true
 }

</script>
	<center><table bgcolor="#$COLORSETUP{'table background'}" bordercolor="#$COLORSETUP{'table bordercolor'}" border=1>
	<tr><td><b>New Entry</b></td></tr>
	<tr><td>
	Date: <input type="text" name="month" length="2" size="2">/<input type="text" name="day" length="2" size="2">/<input type="text" name="year" length="4" size="4"> <input type="checkbox" name="pending" value="1"> Event is tentative<br>
	Departure Time to Location: <input type="text" name="dtime" length="20" size="10">  Setup/Arrival Time: <input type="text" name="stime" length="20" size="10">  Event Time: <input type="text" name="time" length="20" size="10"><br>
	Description: <input type="text" name="location" size="40"><br>
	Client: <input name="clientname" onkeypress="JavaScript:return fakeCombo(this,event);"
        id="txtCombo" class="txtBox" />
        <select name="client" id="selCombo" class="dropDown"
        onChange="JavaScript:changeEmail();" />
	<option value=\"\"></option>
EOT
        foreach $key (keys(%CLIENT_NAME)) {
        	print "<option value=\"$key\"/>$CLIENT_NAME{$key}";
        }
	print "</select><br>\n";

print <<EOT;
	Client's Email Address: <input type="text" name="clientsemail" size="40">
	Client's Phone: <input type="text" name="clientsphone" size="15"><br>
	Fee: \$<input type="text" name="fee" size="10" value=""><br>
	Down payment: \$<input type="text" name="downpayment" size="10" value=""><br>
	Total Round Trip Miles: <input type="text" name="miles" size="10" value=""><br>
	<table border=0>
EOT
        foreach $key (reverse sort keys %LABOR) {
		if ($LABOR{$key} ne "") {
			$youwillwork = "<input type=\"radio\" name=\"you_will_work\" value=\"$key\"> Sign me up for this";
                	$keyname = "NEEDED$key";
			print "<tr><td>$LABOR{$key}s Needed:</td><td><input type=\"text\" name=\"$keyname\" size=\"2\"> $youwillwork</td></tr>\n";
		}
        }

print <<EOT;
	</table>
EOT
	$num=0;
	foreach $gig_type (@EVENT) {
		if ($num > 0 && $EVENT[$num] ne "") {
			print "<input type=\"radio\" name=\"color\" value=\"$num\"><font color=\"#$COLORS[$num]\">$EVENT[$num]  </font>\n";
		}
		$num++;
	}
	print "<br><br></td></tr><tr><td>\n";

        print "Equipment Needed Preset: <select size=\"1\" name=\"preset\">\n";
        print "<option value=\"\">None</option>\n";
        foreach $key (keys(%PRESETNAME)) {
                if ($PRESETNAME{$key}) {
                        print "<option value=\"$key\">$PRESETNAME{$key}</option>\n";
                }   
        }
        print "</select><br>\n";

print <<EOT;
	<input type="checkbox" name="gear" value="1" checked> Edit Equipment Needed For This Event After Submitting<br>
        </td></tr><tr><td>
	<center><table width=100% border=0><tr><td>
	Notes:<br>
	<textarea rows="8" name="notes" cols="25"></textarea><br>
	<input type="checkbox" name="sendout" value="1" checked> Email this event out to everyone<br> 
	<input type="submit" name="new" value="Submit" onClick=\"return ValidateForm()\">
	</td><td>
	</td></tr></table></center></td></tr></table></center>
	<br><br>
	<center><u><font size="5">$title</font></u></center>	<br><br>

<script LANGUAGE="JavaScript">
<!--
function confirmSubmit()
{   
var agree=confirm("You are sure you want to delete this event? You CAN'T undo this!");
if (agree)
        return true ;
else
        return false ;
}
// -->
</script>

EOT

if ($CalView  eq "1") {
##	&getemployee;
	print <<EOT;
	<input type="hidden" name="browsemonth" value="$browsemonth">
        <input type="hidden" name="browseyear" value="$browseyear">
        <input type="hidden" name="iscalendarview" value="true">
EOT
	print "<center><input type=\"submit\" name=\"prevmonth\" value=\"Previous Month\">  <input type=\"submit\" name=\"listview\" value=\"Show as List View\"><input type=\"submit\" name=\"nextmonth\" value=\"Next Month\"></center>\n";

	while(@row = $DBI::result->fetchrow_array) {

	        $date = $row[0];
	        &getlaborneeded;
	        &getcurrentlabor;

		$row[2] =~ s/\"/"/g;
		$row[2] =~ s/\'//g;
		$row[4] =~ s/\"/"/g;
		$row[4] =~ s/\'//g;
		$row[6] =~ s/\"/"/g;
		$row[6] =~ s/\'//g;

		$color = "#$COLORS[$row[1]]";

	        $peopleneeded = 0;
	        foreach $key (sort keys %LABOR) {
			$emptylabor{$key} = $LABORNEEDED{$key} - $CURRENTLABOR{$key};
	                $peopleneeded = $peopleneeded + $emptylabor{$key};
	        }

	        $wy = substr($row[0],2,2);
	        $wm = substr($row[0],4,2);
	        $wd = substr($row[0],6,2);
	
		$datestr = "$wy$wm$wd";
		$wday = `date -d $datestr +%w`;

		$commission = $row[12];
		$income = $row[3] - ($labor + $row[9] + $commission);

		if ($peopleneeded eq "0") {
			$highlight = "#$COLORSETUP{'labor full highlight'}";
		} else {
			$highlight = "#$COLORSETUP{'calendar background'}";
		}
		
		$pendingwarn = "";
		if ($row[22] eq "1") {	## If gig is marked as pending/tentative
			$highlight = "#FF0000";
			$pendingwarn = "<font color=red size=4>This event is tentative!</font><br>";
		}

		$EVENT_BY_DAY{$wd}=$EVENT_BY_DAY{$wd} . "<table>";
		$row[4] =~ s/\n/\\n/ig;
	        $row[4] =~ s/\r//ig;
		$construct = "<table width=400 border=1><tr><td colspan=2>$pendingwarn<small><font color=black>$DAYS[$wday],$row[2]  $row[6]</font></small></td></tr><tr><td width=55% valign=top><font color=black><small>$row[4]</small></font></td><td valign=top><font color=black><small><u>Working:</u><br>@workingnames</small></font></td></tr></table>";
		$EVENT_BY_DAY{$wd}=$EVENT_BY_DAY{$wd} . "<td bgcolor=\"$highlight\"><a href=\"edit.cgi?$row[0]=Edit\" ONMOUSEOVER=\"popup('$construct','yellow')\"\; ONMOUSEOUT=\"kill()\">$row[2]</a></td>";
		$EVENT_BY_DAY{$wd}=$EVENT_BY_DAY{$wd} . "</tr></table><br>\n";
        	$total = $total + $row[3];
	        $totallabor = $totallabor + $labor;
        	$LABORBYTYPE{$row[1]}=$LABORBYTYPE{$row[1]}+$labor;
	        $totalrent = $totalrent + $row[9];
        	$totalcommission = $totalcommission + $commission;
	        $totalincome = $totalincome + $income;
        	$totalmilage = $totalmilage + $row[15];
	        $INCOMEBYTYPE{$row[1]}=$INCOMEBYTYPE{$row[1]}+$income;
		$NUMEVENTS{$row[1]}++;
	        $INCOMEBYCLIENT{$row[18]}=$INCOMEBYCLIENT{$row[18]}+$row[3];
        	$NUMEVENTSBYCLIENT{$row[18]}++;
  	}

	$browsemonth = sprintf ("%02d",$browsemonth);
	$datestr = $browseyear . $browsemonth . "01";
        $startday = `date -d $datestr +%w`;
	$startday =~ s/\n//ig;
	print "<center><table border=1 width=\"1000\">\n";
	print "<tr><td bgcolor=\"$COLORSETUP{'calendar background'}\" width=\"143\">Sunday</td><td bgcolor=\"$COLORSETUP{'calendar background'}\" width=\"143\">Monday</td><td bgcolor=\"$COLORSETUP{'calendar background'}\" width=\"143\">Tuesday</td><td bgcolor=\"$COLORSETUP{'calendar background'}\" width=\"143\">Wednesday</td><td bgcolor=\"$COLORSETUP{'calendar background'}\" width=\"143\">Thursday</td><td bgcolor=\"$COLORSETUP{'calendar background'}\" width=\"143\">Friday</td><td bgcolor=\"$COLORSETUP{'calendar background'}\" width=\"143\">Saturday</td></tr>\n";
	$myday=0;
	$printcalendar=1;
	$rows=1;
	$numberofdays = `cal $browsemonth \`date +$browseyear\` | egrep -v '[A-Za-z]' | wc -w`;
	$numberofdays =~ s/\n//ig;
	$currentmonth = `date +%m`;
	$currentmonth =~ s/\n//ig;
	$currentday = `date +%d`;
	$currentday =~ s/\n//ig;
	$currentyear = `date +%Y`;
	$currentyear =~ s/\n//ig;
	while ($myday <= $numberofdays && $rows < 7) {
		if ($myday <= $numberofdays) {
			$mywday=0;
			for (0..6) {
				if ($myday <= $numberofdays) {
                                if ($mywday eq "0") {
                                        print "<tr height=\"150\">\n";
                                }
				if ($myday eq "0") {
					if ($startday eq $mywday) {
						$myday=1;
						$todaycolor = "#$COLORSETUP{'calendar background'}";
						if ($currentday eq $myday && $currentmonth eq $browsemonth && $currentyear eq $browseyear) {
							$todaycolor = "#$COLORSETUP{'calendar today'}";
						}
						$mydayf = sprintf("%02d",$myday);
						print "<td bgcolor=\"$todaycolor\" valign=\"top\">1.<br>$EVENT_BY_DAY{$mydayf}</td>\n";
						$myday++;
					} else {
						print "<td bgcolor=\"#$COLORSETUP{'background'}\"></td>\n";
					}
				} else {
					$todaycolor = "#$COLORSETUP{'calendar background'}";
					if ($currentday eq $myday && $currentmonth eq $browsemonth && $currentyear eq $browseyear) {
						$todaycolor = "#$COLORSETUP{'calendar today'}";
					}
					$mydayf = sprintf("%02d",$myday);
					print "<td bgcolor=\"$todaycolor\" valign=\"top\">$myday.<br>$EVENT_BY_DAY{$mydayf}</td>\n";
					$myday++;
				}
				if ($mywday eq "6") {
					print "</tr>\n";
				}
				$mywday++;	
				}
			}
			$rows++;
		}
	}
	print "</table>\n";
} else {

print "<center><table bgcolor=\"#$COLORSETUP{'table background'}\" bordercolor=\"#$COLORSETUP{'table bordercolor'}\" border=1><tr><td>\n";
print "<center>FROM <input type=\"text\" name=\"frommonth\" size=\"2\" maxlength=\"2\">/\n";
print "<input type=\"text\" name=\"fromday\" size=\"2\" maxlength=\"2\">/\n";
print "<input type=\"text\" name=\"fromyear\" size=\"4\" maxlength=\"4\"> TO \n";
print "<input type=\"text\" name=\"tomonth\" size=\"2\" maxlength=\"2\">/\n";
print "<input type=\"text\" name=\"today\" size=\"2\" maxlength=\"2\">/\n";
print "<input type=\"text\" name=\"toyear\" size=\"4\" maxlength=\"4\"></center>\n";
print "<input type=\"checkbox\" name=\"showactive\" value=\"1\" checked>Show Active Events (future events)  <input type=\"checkbox\" name=\"showinactive\" value=\"1\" checked>Show Inctive Events (past events)<br><br>\n";
print "<center><input type=\"submit\" name=\"showhist\" value=\"View History\"></center>\n";
if ($FORM{'showhist'}) {
	print "<center><input type=\"submit\" name=\"show\" value=\"Show Current Gigs\"></center>\n";
}
print "</td></tr></table><br><br>\n";
print "<center><input type=\"submit\" name=\"calendarview\" value=\"Show as Calendar View\"></center>\n";
print "<center><table border=1 width=\"1000\">\n";

print "<tr><td bgcolor=\"$COLORSETUP{'calendar background'}\">&nbsp;</td>\n";

foreach $key (reverse sort keys %LABOR_ABB) {
	if ($LABOR_ABB{$key} ne "") {
		print "<td bgcolor=\"$COLORSETUP{'calendar background'}\"><small>$LABOR_ABB{$key}</small></td>\n";
	}
}
print "<td bgcolor=\"$COLORSETUP{'calendar background'}\">Date & Description</td><td bgcolor=\"$COLORSETUP{'calendar background'}\">Time</td><td bgcolor=\"$COLORSETUP{'calendar background'}\">Fee</td><td bgcolor=\"$COLORSETUP{'calendar background'}\">Payment Received</td><td bgcolor=\"$COLORSETUP{'calendar background'}\">Labor</td><td bgcolor=\"$COLORSETUP{'calendar background'}\"><small>Commission</small></td><td bgcolor=\"$COLORSETUP{'calendar background'}\">Income</td><td bgcolor=\"$COLORSETUP{'calendar background'}\">Miles</td><td bgcolor=\"$COLORSETUP{'calendar background'}\">Notes</td><td bgcolor=\"$COLORSETUP{'calendar background'}\">Attachments</td><td bgcolor=\"$COLORSETUP{'calendar background'}\">Who</td><td bgcolor=\"$COLORSETUP{'calendar background'}\">&nbsp;</td>\n";

##&getemployee;

while(@row = $DBI::result->fetchrow_array) {

	$date = $row[0];
	&getlaborneeded;
	&getcurrentlabor;

	$row[2] =~ s/\"/"/g;
	$row[2] =~ s/\'//g;
	$row[4] =~ s/\"/"/g;
	$row[4] =~ s/\'//g;
	$row[6] =~ s/\"/"/g;
	$row[6] =~ s/\'//g;

	$color = "#$COLORS[$row[1]]";

	$peopleneeded = 0;
	foreach $key (sort keys %LABOR) {
		$emptylabor{$key} = $LABORNEEDED{$key} - $CURRENTLABOR{$key};		
		$peopleneeded = $peopleneeded + $emptylabor{$key};
	}

        $wy = substr($row[0],2,2);
        $wm = substr($row[0],4,2);
        $wd = substr($row[0],6,2);
	
	$datestr = "$wy$wm$wd";
	$wday = `date -d $datestr +%w`;
	$commission = $row[12];


	if ($row[14] eq "0" && $row[12] > 0) {
		$compaid = "<font><b>";
		$compaid2 = "</font></b>";
	} else {
		$compaid = "";
		$compaid2 = "";
	}

	$income = $row[3] - ($labor + $row[9] + $commission);

	if ($peopleneeded eq "0") {
		$highlight = "#$COLORSETUP{'labor full highlight'}";
	} else {
		$highlight = "#$COLORSETUP{'calendar background'}";
	}

        $pendingwarn = "";
        if ($row[22] eq "1") {  ## If gig is marked as pending/tentative
                $highlight = "#FF0000";
                $pendingwarn = "<font color=white size=3>This event is tentative!</font><br>";
        }


	$laborneededhtml = "";
        foreach $key (sort keys %LABOR) {
		if ($LABOR{$key} ne "") {
                	$laborneededhtml = $laborneededhtml . "<td bgcolor=\"$highlight\"><font color=\"$color\">$emptylabor{$key}</font></td>\n";
		}
        }

	if ($row[21] eq "1") {
		$payment_received = "<font color=\"green\">YES</font>";
	} else {
		$payment_received = "<font color=\"red\">NO</font>";
	}

	$files = $row[16];

	if ($row[22] eq "1") {
		print "<tr><td bgcolor=\"$highlight\"><input type=\"submit\" name=\"$row[0]\" value=\"Approve\"></td>\n";
	} else {
		print "<tr><td bgcolor=\"$highlight\"><input type=\"submit\" name=\"$row[0]\" value=\"$d\"></td>\n";
	}

	print $laborneededhtml;
	print "<td bgcolor=\"$highlight\"><font color=\"$color\">$pendingwarn$DAYS[$wday], $row[2]</font></td><td bgcolor=\"$highlight\"><font color=\"$color\">$row[6]&nbsp;</font></td><td bgcolor=\"$highlight\"><font color=\"$color\">\$$row[3]</font></td><td bgcolor=\"$highlight\"><font color=\"$color\">$payment_received</font><td bgcolor=\"$highlight\"><font color=\"$color\">\$$labor</font></td><td bgcolor=\"$highlight\"><font color=\"$color\">$compaid\$$commission$compaid2</font></td><td bgcolor=\"$highlight\"><font color=\"$color\">\$$income</font></td>\n";
        print "<td bgcolor=\"$highlight\"><font color=\"$color\">$row[15]</font></td>\n";

	if ($row[4] ne "") {
		$row[4] =~ s/\n/\\n/ig;
                $row[4] =~ s/\r//ig;
		print "<td bgcolor=\"$highlight\"><a href=\"edit.cgi\" ONMOUSEOVER=\"popup('<font color=black>$row[4]</font>','yellow')\"\; ONMOUSEOUT=\"kill()\">Notes</a></td>\n";
	} else {
		print "<td bgcolor=\"$highlight\"><font color=\"#E0E0E0\">No Notes</font></td>\n";
	}
        print "<td bgcolor=\"$highlight\"><font size=\"1\"><small>$files</font></small></td>\n";
	print "<td width=\"100\" bgcolor=\"$highlight\"><font color=\"$color\">\n";
	$br = "";
	foreach $worker (@working) {
		if ($worker ne "") {
			print "$br$EMPLOYEES{$worker}\n";
			$br = "<br> ";
		}
	}
	print "</font></td>\n";
	print "<td bgcolor=\"$highlight\"><center><input type=\"submit\" name=\"$row[0]\" value=\"Edit\"><br><input type=\"submit\" name=\"$row[0]\" id=\"$row[0]\" value=\"Delete\" OnClick=\"return confirmSubmit()\"></center></td></tr>\n";
	$total = $total + $row[3];
	$totallabor = $totallabor + $labor;
	$LABORBYTYPE{$row[1]}=$LABORBYTYPE{$row[1]}+$labor;
	$totalrent = $totalrent + $row[9];
	$totalcommission = $totalcommission + $commission;
	$totalincome = $totalincome + $income;
	$totalmilage = $totalmilage + $row[15];
	$INCOMEBYTYPE{$row[1]}=$INCOMEBYTYPE{$row[1]}+$income;
	$INCOMEBYCLIENT{$row[18]}=$INCOMEBYCLIENT{$row[18]}+$row[3];
	$NUMEVENTSBYCLIENT{$row[18]}++;
	$NUMEVENTS{$row[1]}++;
	}

}
print "</table><br><br><center><table>\n";
print "<tr><td><b>Gross Total:</b></td><td>\$$total</b></td></tr>\n";
print "<tr><td><b>Total Labor:</b></td><td>\$$totallabor</b></td></tr>\n";
print "<tr><td><b>Total Rent:</b></td><td>\$$totalrent</b></td></tr>\n";
print "<tr><td><b>Total Commission:</b></td><td>\$$totalcommission</b></td></tr>\n";
print "<tr><td><b>Total Income:</b></td><td>\$$totalincome</b></td></tr>\n";
print "<tr><td><b>Total Milage:</b></td><td>$totalmilage</b></td></tr></table></center> <br><br> \n";


if ($FORM{'showhist'}) {
	$DBI::result = $dbh->prepare($COMMISSIONSQL);
	$DBI::result->execute();
} else {
	$DBI::result = $dbh->prepare("select * from `gigs` WHERE `commissionvalue`>0 ORDER BY `date` ASC");
	$DBI::result->execute();
}

while(@row = $DBI::result->fetchrow_array) {
	$commission = $row[12];
	$commissionemp{$row[13]} = 1; ##Assign a name for the person commission is granted to into an array
	if ($row[14] eq "1") {
		$COMPAID{$row[13]} = $COMPAID{$row[13]} + $commission;
	} else {
		if ($row[5] eq "0") {
			$COMOWE{$row[13]} = $COMOWE{$row[13]} + $commission;
		}
	}
}

print "<center><font size=\"4\">Commission</font></center>\n";
print "<center><table bgcolor=\"#$COLORSETUP{'table background'}\" bordercolor=\"#$COLORSETUP{'table bordercolor'}\" border=1>\n";
print "<tr><td>Name</td><td>Paid</td><td>Owe</td></tr>\n";

foreach $ename (keys(%commissionemp)) {
	print "<tr><td>$ename</td><td>$COMPAID{$ename}&nbsp;</td><td>$COMOWE{$ename}&nbsp;</td></tr>\n";
}
print "</table></center><br><br>\n";




print "<center><font size=\"4\">Payroll</font></center>\n";
print "<center><table bgcolor=\"#$COLORSETUP{'table background'}\" bordercolor=\"#$COLORSETUP{'table bordercolor'}\" border=1>\n";
print "<tr><td>Name</td><td>Amount</td><td>Events</td></tr>\n";

$DBI::result = $dbh->prepare("select * from `employees`");
$DBI::result->execute();

while(@row = $DBI::result->fetchrow_array) {
	$num = $row[0];
	if ($EMPPAID{$num}) {
		print "<tr><td>$row[1]</td><td>$EMPPAID{$num}&nbsp;</td><td>$EMPGIGS{$num}&nbsp;</td></tr>\n";
	}
}
print "</table></center><br><br>\n";

print "<center><font size=\"4\">Income & Labor by Event Type</font></center>\n";
print "<center><table bgcolor=\"#$COLORSETUP{'table background'}\" bordercolor=\"#$COLORSETUP{'table bordercolor'}\" border=1>\n";
print "<tr><td>Event Type</td><td>Income</td><td>Labor</td><td># of events</td></tr>\n";
$num=0;
foreach $gig_type (@EVENT) {
	if ($num > 0 && $EVENT[$num] ne "") {
		print "<tr><td><font color=\"#$COLORS[$num]\">$EVENT[$num]  </font></td><td>$INCOMEBYTYPE{$num}</td><td>$LABORBYTYPE{$num}</td><td>$NUMEVENTS{$num}</td></tr>\n";
	}
	$num++;
}
print "</table></center><br><br>\n";

print "<center><font size=\"4\">Gross Income by Client</font></center>\n";
print "<center><table bgcolor=\"#$COLORSETUP{'table background'}\" bordercolor=\"#$COLORSETUP{'table bordercolor'}\" border=1>\n";
print "<tr><td>Client</td><td>Income</td><td># of events</td></tr>\n";
foreach $key (keys(%CLIENT_NAME)) {
	print "<tr><td>$CLIENT_NAME{$key}</td><td>$INCOMEBYCLIENT{$key}</td><td>$NUMEVENTSBYCLIENT{$key}</td></tr>\n";
}
print "</table></center>\n";


&credit;

sub panic {
        print "Content-type:text/html\n\n";
        print "<center><h1><font color=\"$COLORSETUP{'error font'}\">ERROR</h1></font></center>\n";
        print "<center><font size=5 color=\"$COLORSETUP{'error font'}\">$message</font></center>\n";
}

sub credit {
	print "<br><br><center><a href=\"http://nason.com\">Schedule'N Event Management 2.3 &copy;2008 Nason Tackett</a></center>\n";  
}


$dbh->disconnect();
exit;

sub showreg {
        open(REG,"schedulen.key");
        @regfile = <REG>;
        close REG;
        
        print <<EOT;
	<body bgcolor="#FFFFFF" text="#000000">
        <FORM METHOD="POST" ACTION="edit.cgi" name="mainform">
        <input type="hidden" name="username" value="$username">
        <center><table bgcolor="#FFFFFF" bordercolor="#000000" border=1>
        <tr><td><b>Registration</b></td></tr>
        <tr><td>Registered To: <input type=\"text\" name=\"regname\" size=\"100\" value=\"$regfile[0]\"></td></tr>
        <tr><td>Registration Key: <input type=\"text\" name=\"regkey\" size=\"100\" value=\"$regfile[1]\"></td></tr>
        </table></center><br>
	<center><a href=\"http://nason.com/cgi-bin/demo.cgi\">Click Here for a Demo Key</a></center><br>
        <center><input type="submit" name="editregistration" value="Update Registration"></center><br>
	<br><br><center><a href=\"http://nason.com\">Visit our website for instructional videos, help, or to contact us.</a></center><br>
EOT
}
1;
                        
sub updateregistration {
        open(REG,">schedulen.key");
        print REG "$FORM{'regname'}\n";
        print REG "$FORM{'regkey'}\n";
        close REG;
}
1;      

sub header {

	print "<body bgcolor=\"#$COLORSETUP{'background'}\" text=\"#$COLORSETUP{'default font'}\">\n";
	print "<center><img src=\"$SETUP{'Company Logo'}\"></center>\n";
	print "<center><font size=5>$SETUP{'Company Name'} Event Management</font></center><br>\n";
	print "<center><font size=3>$SETUP{'Shipping Address'}<br>$SETUP{'Shipping City'}, $SETUP{'Shipping State'}  $SETUP{'Shipping Zip'}<br>$SETUP{'Phone Number'}</font></center><br>\n";
	print "<FORM METHOD=\"POST\" name=\"toolbar\" ACTION=\"edit.cgi\">\n";
	print "<input type=\"hidden\" name=\"username\" value=\"$username\">\n";
	print "<center><table bgcolor=\"#$COLORSETUP{'table background'}\" bordercolor=\"#$COLORSETUP{'table bordercolor'}\" border=1><tr><td><input type=\"submit\" name=\"show\" value=\"Show Schedule\"><input type=\"submit\" name=\"editemployees\" value=\"Edit Employees\"><input type=\"submit\" name=\"editclient\" value=\"Edit Clients\"><input type=\"submit\" name=\"editinventory\" value=\"Edit Inventory\"><input type=\"submit\" name=\"setup\" value=\"Setup\"></td></tr></table></center>\n";
	print "</form>\n";
	if ($SETUP{'Link At Top'} && $SETUP{'Link At Top Name'}) {
		print "<center><font size=4><a href=\"$SETUP{'Link At Top'}\">$SETUP{'Link At Top Name'}</a></font></center>\n";
	}
	if ($schedulen eq "-1") {
		$edate = `./gooduntil`;
		$efdate = `date -d '1970-01-01 $edate sec' +"%A, %B %d, %Y"`;
		print "<center><font color=\"$COLORSETUP{'error font'}\" size=5>30 day trial version</font></center>\n";
		print "<center><font color=\"$COLORSETUP{'error font'}\" size=3>Good Until: $efdate</font></center>\n";
	}
}
1;
