#!/usr/bin/perl

###################################################
#### 	  developed by: Nason Tackett          ####
####             nason@nason.com               ####
###################################################

sub WARN_handler {              ## Redefine PERL's warn & die handelers to print any errors to the screen
        my($signal) = @_;
        print "<font size=4 color=red>ERROR: $signal</font><br>\n";
}
 
$SIG{__DIE__} = 'WARN_handler';
$SIG{__WARN__} = 'WARN_handler';


read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/~!/ ~!/g;
    $value =~ s/"/\&quot\;/g;
    $value =~ s/'/\'/g;
    $FORM{$name} = $value;
}

## Make and array out of the query string
@strings = split(/&/, $ENV{'QUERY_STRING'});
foreach $string (@strings) {
        $string =~ s/%20/ /i;
        $string =~ s/\+/ /ig;
        $string =~ s/\%7C/\|/ig;
        $string =~ s/\%24/\$/ig;
        $string =~ s/\%0A//ig;
        $string =~ s/\%2F/\//ig;
        $string =~ s/\%26/\&/ig;
        $string =~ s/\%27/'/ig;
        $string =~ s/\%28/(/ig;
        $string =~ s/\%29/)/ig;
        ($name,$value) = split(/=/,$string);
        $QUERY{$name} = $value;
}

chdir("../edit");
$schedulen = `./schedulen`;
$schedulen =~ s/\n//ig;
if ($schedulen ne "0" && $schedulen ne "-1") {
        $message = "$schedulen\n";
        &panic;
        exit;
}
chdir("../employee");

if ($ENV{'REMOTE_USER'} ne "") {
        $username = $ENV{'REMOTE_USER'};
} elsif ($FORM{'username'} ne "") {   
        $username = $FORM{'username'};
} else {
        $message = "Unable to log you in... This could be caused by the directory password protection not functioning properly on this server.";
        &panic;
        exit;
}


use DBI();
require "../db.cfg";       ## Database Connection
require "../edit/employee.inc";
require "../edit/gig.inc";
require "../edit/client.inc";
require "../edit/gear.inc";

$DBI::result = $dbh->prepare("select * from `color setup`");
$DBI::result->execute();
while(@row = $DBI::result->fetchrow_array) {
	$COLORSETUP{$row[1]}=$row[2];
}

$DBI::result = $dbh->prepare("select * from `setup`");
$DBI::result->execute();
while(@row = $DBI::result->fetchrow_array) {
        $SETUP{$row[0]} = $row[1];
}

$DBI::result = $dbh->prepare("select * from `gig types`");
$DBI::result->execute();
while(@row = $DBI::result->fetchrow_array) {
        $EVENT[$row[0]]=$row[1];
        $COLORS[$row[0]]=$row[2];
}

$DBI::result = $dbh->prepare("select * from `labor types`");
$DBI::result->execute();
while(@row = $DBI::result->fetchrow_array) {
        $key = $row[0];
        $LABOR{$key}=$row[1];
        $LABOR_ABB{$key}=$row[2];
}

@DAYS = ("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");
@month = ("", "Jan", "Feb", "March", "April", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec");

print "Content-type:text/html\n\n";
print "<body bgcolor=\"#$COLORSETUP{'background'}\" text=\"#$COLORSETUP{'default font'}\">\n";
print "<center><img src=\"$SETUP{'Company Logo'}\"></center>\n";
print "<center><font size=5>$SETUP{'Company Name'} Event Management</font></center><br>\n";
print "<center><font size=3>$SETUP{'Shipping Address'}<br>$SETUP{'Shipping City'}, $SETUP{'Shipping State'}  $SETUP{'Shipping Zip'}<br>$SETUP{'Phone Number'}</font></center><br>\n";

chdir("../edit");
if ($schedulen eq "-1") {
        $edate = `./gooduntil`;
        $efdate = `date -d '1970-01-01 $edate sec' +"%A, %B %d, %Y"`;
        print "<center><font color=\"#$COLORSETUP{'error font'}\" size=5>30 day trial version</font></center>\n";
        print "<center><font color=\"#$COLORSETUP{'error font'}\" size=3>Good Until: $efdate</font></center>\n";
}
chdir("../employee");

unless (-e "notes.html" && $ENV{'HTTP_REFERER'} !~ /employee.cgi/) {
	print "<FORM METHOD=\"POST\" name=\"toolbar\" ACTION=\"employee.cgi\">\n";
	print "<input type=\"hidden\" name=\"username\" value=\"$username\">\n";
	print "<center><table bgcolor=\"#$COLORSETUP{'table background'}\" bordercolor=\"#$COLORSETUP{'table bordercolor'}\" border=1><tr><td><input type=\"submit\" name=\"show\" value=\"Show Schedule\"><input type=\"submit\" name=\"directory\" value=\"Phone & Email Directory\"><input type=\"submit\" name=\"settings\"value=\"Account Settings\"></td></tr></table></center>\n";
	print "</form>\n";
}

$DBI::result = $dbh->prepare("select * from `employees` WHERE `username` = \"$username\"");
$DBI::result->execute();

while(@row = $DBI::result->fetchrow_array) {

	$realname = $row[1];	
	$employeenum = $row[0];
	$active = $row[2];
	$isAdmin = $row[15];
	$CalView = $row[16];
	$lastlogin = $row[19];
}

if ($FORM{'hisyear'}) {
	$beginyear = $FORM{'hisyear'};
	$today = "$FORM{'hisyear'}1231";
} else {
	$beginyear = `date +%Y`;
	chop($beginyear);
	$today = `date +%Y%m%d`;
}

chop($begyear);
$begyear = $beginyear . "0101";

$DBI::result = $dbh->prepare("select * from `gig labor` WHERE `employee`=\"$employeenum\" AND (`date` >= \"$begyear\" AND `date` < \"$today\")");
$DBI::result->execute();
$gigs = 0;

while(@row = $DBI::result->fetchrow_array) {
	$gigs++;
	$moneymade = $moneymade + $row[3];
}

$DBI::result = $dbh->prepare("select * from `gig labor` WHERE `employee`=\"$employeenum\" AND `date` >= \"$today\"");
$DBI::result->execute();
$upgigs = 0;

while(@row = $DBI::result->fetchrow_array) {
	$upgigs++;
}

print "<center><font size=3>Hello $realname, You have worked $gigs events and made \$$moneymade this year ($beginyear).</font></center>\n";
print "<center><font size=3>You are currently signed up to work $upgigs events.</font></center>\n";
print "<center><font size=3><a href=\"http://$SETUP{'Domain Name'}\">Click here to logout</a></font></center>\n";
if ($ENV{'HTTP_REFERER'} !~ /employee.cgi/) {
        $datestamp = `date`;
        $datestamp =~ s/\n//ig;
        $dbh->do("UPDATE `employees` SET `last login` = \"$datestamp\" WHERE `num` = \"$employeenum\"");
        print "<center><b>Last Login: $lastlogin</b></center><br>\n";
}

foreach $key (%FORM) {
	if ($FORM{$key} =~ /Signup as/) {
		($edit,$type) = split(/-/,$key);
		&getDatesByEmployee;
		&sign;
        } elsif ($FORM{$key} eq "View Equipment List") {
		$hide=1;
        	$date = $key;
        	&editgear;
		&credit;
        	$dbh->disconnect();
        	exit;		
	} elsif ($FORM{$key} eq "View") {
		$edit = $key;
		$date = $key;
		&printjavawarn;
		&getemployeelabortypes;
	        &getlaborneeded;
        	&getcurrentlabor;
		&getDatesByEmployee;
		&generateSignupButtons;
		$hide=1;
		&edit;
		&credit;
		$dbh->disconnect();
		exit;
	} elsif ($FORM{$key} eq "Submit Changes") {
		&changes;
        	&settings;
        	&credit;  
        	$dbh->disconnect();
        	exit;
	} elsif ($FORM{$key} eq "Change Password") {
		&changepasswd;
	        &settings;
        	&credit;  
        	$dbh->disconnect();
        	exit;
	}
}

if ($FORM{'settings'}) {
	&settings;
	&credit;
	$dbh->disconnect();
	exit;
} elsif ($FORM{'directory'} || $FORM{'showinactivedirectory'}) {
        &directory;
        &credit;
        $dbh->disconnect();
        exit;
}

foreach $key (%QUERY) {
	if ($QUERY{$key} eq "View") {
                $edit = $key;
		$date = $key;
		&printjavawarn;
		&getemployeelabortypes;
		&getlaborneeded;
		&getcurrentlabor;
		&getDatesByEmployee;
		&generateSignupButtons;
                $hide=1;
                &edit;
		&credit;
                $dbh->disconnect();
                exit;
	}
}

if ($FORM{'prevmonth'}) {
        if ($FORM{'browsemonth'} eq "1") {
                $FORM{'browseyear'}--;
                $FORM{'browsemonth'}=12;
        } else {
                $FORM{'browsemonth'}--;
        }
}
        
if ($FORM{'nextmonth'}) {
        if ($FORM{'browsemonth'} eq "12") {
                $FORM{'browseyear'}++;
                $FORM{'browsemonth'}=1;
        } else {
                $FORM{'browsemonth'}++;
        }
}

if ($FORM{'calendarview'}) {
	$dbh->do("UPDATE `employees` SET `CalView` = \"1\" WHERE `num` = \"$employeenum\"");	
	$CalView=1;
}   
    
if ($FORM{'listview'}) {
 	$dbh->do("UPDATE `employees` SET `CalView` = \"0\" WHERE `num` = \"$employeenum\"");
	$CalView=0;
}   

open(HEAD,"popup.html");
@HEAD = <HEAD>;
close HEAD;
foreach $line (@HEAD) {
	print $line;
}

if (-e "notes.html" && $ENV{'HTTP_REFERER'} !~ /employee.cgi/) {
print <<EOT;
	<form name="top" action="employee.cgi" method="post">
	<input type="hidden" name="username" value="$username">
	<center><table borderColor="#$COLORSETUP{'table bordercolor'}" bgColor="#$COLORSETUP{'table background'}" border="1" width="700">
        <tr><td>
EOT
	open(NOTES,"notes.html");
	@NOTESFILE = <NOTES>;
	print @NOTESFILE;
	close NOTES;
print <<EOT;
	</td></tr>
	<tr><td>
	<center><input type="submit" name="agree" value="I Agree"></center>
	</td></tr></table>
EOT
	exit;	
}

print "<form name=\"top\" action=\"employee.cgi\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"username\" value=\"$username\">\n";
&getemployeelabortypes;
&getemployee;


if ($CalView  eq "1") {
        if ($FORM{'browseyear'} ne "") {
                $browseyear = $FORM{'browseyear'};
        } else {
                $browseyear = `date +%Y`;
                $browseyear =~ s/\n//ig;
        }
        if ($FORM{'browsemonth'} ne "") {
                $browsemonth = $FORM{'browsemonth'};
        } else {
                $browsemonth = `date +%m`;
                $browsemonth =~ s/\n//ig;
        }
        $title = "$month[$browsemonth], $browseyear";
        $begmon = ($browseyear * 10000) + ($browsemonth * 100);
        $endmon = $begmon + 100;
	&getDatesByEmployee;
        $DBI::result = $dbh->prepare("select * from `gigs` WHERE `date` >= \"$begmon\" AND `date` < \"$endmon\" ORDER BY `date` ASC");
        $DBI::result->execute();
} else {
	if ($FORM{'showhist'}) {
		if ($FORM{'hisyear'}) {
			$title = "Showing History for $FORM{'hisyear'}";
			$arewere = "<font color=\"#$COLORSETUP{'labor full highlight'}\">(Events that you worked are highlighted in this color.)</font>";
			$d = "Undo";
			$hisyear = $FORM{'hisyear'} * 10000;
			$ltyear = $hisyear + 10000;
			$DBI::result = $dbh->prepare("select * from `gigs` WHERE `active`='0' AND `date` >= \"$hisyear\" AND `date` < \"$ltyear\" ORDER BY `date` DESC");
			$DBI::result->execute();
		} else {
			$title = "Showing All Past History";
			$arewere = "<font color=\"#$COLORSETUP{'labor full highlight'}\">(Events that you worked are highlighted in this color.)</font>";
			$d = "Undo";
		        $DBI::result = $dbh->prepare("select * from `gigs` WHERE `active`='0' ORDER BY `date` DESC");
		        $DBI::result->execute();
		}
	} else {
		$title = "Current Dates";	
		$arewere = "<font color=\"#$COLORSETUP{'labor full highlight'}\">(Events in which you are signed up to work are highlighted in this color.)</font>";
		$d = "Done";
		&getDatesByEmployee;
		$DBI::result = $dbh->prepare("select * from `gigs` WHERE `active`='1' ORDER BY `date` ASC");
		$DBI::result->execute();
	}
}

print "<br><center><u><font size=\"5\">$title</font></u></center>\n";
print "<center><font size=\"2\">$arewere</font></center><br>\n";

if ($CalView eq "1") {
        print <<EOT;
	<input type="hidden" name="username" value="$username">
        <input type="hidden" name="browsemonth" value="$browsemonth">
        <input type="hidden" name="browseyear" value="$browseyear">
        <input type="hidden" name="iscalendarview" value="true">
EOT
        print "<center><input type=\"submit\" name=\"prevmonth\" value=\"Previous Month\">  <input type=\"submit\" name=\"listview\" value=\"Show as List View\"><input type=\"submit\" name=\"nextmonth\" value=\"Next Month\"></center>\n";
	print "<center><small><font color=\"#$COLORSETUP{'labor full highlight'}\">Events in which you are signed up for are highlighted in this color. </font><font color=\"#$COLORSETUP{'signup ok highlight'}\">Events in which you may sign up for are highlighted in this color.</font></small></center>\n";
        
        while(@row = $DBI::result->fetchrow_array) {
        
	        $date=$row[0];
	        &getlaborneeded;
	        &getcurrentlabor;
        
	        $row[2] =~ s/\"/"/g;
	        $row[2] =~ s/\'/`/g;
	        $row[4] =~ s/\"/"/g;
	        $row[4] =~ s/\'/`/g;
	        $row[6] =~ s/\"/"/g;
	        $row[6] =~ s/\'/`/g;

	        $color = "#$COLORS[$row[1]]";

	        $peopleneeded = 0;
	        %emptylabor=();
	        foreach $key (sort keys %LABOR) {                       ## Calculate the empty labor slots needed
	                $emptylabor{$key} = $LABORNEEDED{$key} - $CURRENTLABOR{$key};
	                $peopleneeded = $peopleneeded + $emptylabor{$key};
	        }
   
		($thisdatesplit,$junk) = split(/\./,$row[0]);

		$highlight = "";
	        if ($active && $row[5] eq "1") {
			$signedup="";
			if ($EMPLOYEEBYGIG{$row[0]} eq "1") {
				$highlight = "#$COLORSETUP{'labor full highlight'}";
			} else {
                  	foreach $key (keys %emptylabor) {
                                if ($emptylabor{$key} > 0 && $EMPLABOR[$employeenum][$key] eq "1") {
                                        if ($EMPLOYEEBYDATE{$thisdatesplit} ne "1") {
						$highlight = "#$COLORSETUP{'signup ok highlight'}";
                                        }
                                }
                        }
			}
	        } else {
			$highlight = "#$COLORSETUP{'calendar background'}";
        	}

                $pendingwarn = "";
                if ($row[22] eq "1") {  ## If gig is marked as pending/tentative
                        $highlight = "#FF0000";
                        $pendingwarn = "<font color=red size=4>This event is tentative!</font><br>";
                }

	        $wy = substr($row[0],2,2);
	        $wm = substr($row[0],4,2);
	        $wd = substr($row[0],6,2);
        
	        $datestr = "$wy$wm$wd";
	        $wday = `date -d $datestr +%w`;
        
	        $EVENT_BY_DAY{$wd}=$EVENT_BY_DAY{$wd} . "<table><tr>";
                $row[4] =~ s/\n/\\n/ig;
                $row[4] =~ s/\r//ig;
		$construct = "<table width=400 border=1><tr><td colspan=2>$pendingwarn<small><font color=black>$DAYS[$wday], $row[2]  $row[6]</font></small></td></tr><tr><td width=55% valign=top><small><font color=black>$row[4]</font></small></td><td valign=top><small><font color=black><u>Working:</u><br>@workingnames</small></font></td></tr></table>";
                $EVENT_BY_DAY{$wd}=$EVENT_BY_DAY{$wd} . "<td bgcolor=\"$highlight\"><a href=\"employee.cgi?$row[0]=View\" ONMOUSEOVER=\"popup('$construct','yellow')\"\; ONMOUSEOUT=\"kill()\">$row[2]</a></td>";
	        $EVENT_BY_DAY{$wd}=$EVENT_BY_DAY{$wd} . "</tr></table><br>\n";
        }

        $browsemonth = sprintf ("%02d",$browsemonth);
        $datestr = $browseyear . $browsemonth . "01";
        $startday = `date -d $datestr +%w`;
        $startday =~ s/\n//ig;
        print "<center><table border=1 width=\"1000\">\n";
        print "<tr><td width=\"143\">Sunday</td><td width=\"143\">Monday</td><td width=\"143\">Tuesday</td><td width=\"143\">Wednesday</td><td width=\"143\">Thursday</td><td width=\"143\">Friday</td><td width=\"143\">Saturday</td></tr>\n";
        $myday=0;
        $printcalendar=1;
        $rows=1;
        $numberofdays = `cal $browsemonth \`date +$browseyear\` | egrep -v '[A-Za-z]' | wc -w`;
        $numberofdays =~ s/\n//ig; 
        $currentmonth = `date +%m`;
        $currentmonth =~ s/\n//ig;
        $currentday = `date +%d`;
        $currentday =~ s/\n//ig;  
        $currentyear = `date +%Y`;
        $currentyear =~ s/\n//ig;

        while ($myday <= $numberofdays && $rows < 7) {
                if ($myday <= $numberofdays) {
                        $mywday=0;  
                        for (0..6) {
                                if ($myday <= $numberofdays) {
                                if ($mywday eq "0") {
                                        print "<tr height=\"150\">\n";
                                }
                                if ($myday eq "0") {
                                        if ($startday eq $mywday) {
                                                $myday=1;
                                                $todaycolor = "white";
                                                if ($currentday eq $myday && $currentmonth eq $browsemonth && $currentyear eq $browseyear) {
                                                        $todaycolor = "#FFFF99";
                                                }
                                                $mydayf = sprintf("%02d",$myday);
                                                print "<td bgcolor=\"$todaycolor\" valign=\"top\">1.<br>$EVENT_BY_DAY{$mydayf}</td>\n";
                                                $myday++;
                                        } else {
                                                print "<td></td>\n";  
                                        }
                                } else {   
                                        $todaycolor = "white";  
                                        if ($currentday eq $myday && $currentmonth eq $browsemonth && $currentyear eq $browseyear) {
                                                $todaycolor = "#FFFF99";
                                        }
                                        $mydayf = sprintf("%02d",$myday);
                                        print "<td bgcolor=\"$todaycolor\" valign=\"top\">$myday.<br>$EVENT_BY_DAY{$mydayf}</td>\n";
                                        $myday++;
                                }
                                if ($mywday eq "6") {
                                        print "</tr>\n";
                                }
                                $mywday++; 
                                }
                        }
                        $rows++;
                }
        }
        print "</table>\n";
} else {

print <<EOT;
<center><table borderColor="#$COLORSETUP{'table bordercolor'}" bgColor="#$COLORSETUP{'table background'}" border="1" width="700">
    <tr>
        <td colspan="2" width="690">
	   <center><font face="Courier New" size="4">Event Display</font>
	</td>
    </tr>
    <tr>
	<td width="35%">	
          <p align="center"><input type="submit" value="Show Current" name="show">
      </td>
	<td width="65%">	
          <center>Show History by year: <input size="4" name="hisyear"> (type a 4 digit year)<input type="submit" value="View History" name="showhist"></center>
      </td>
    </tr>
  </table></center><br>
EOT

&printjavawarn;

print <<EOT;
<input type="hidden" name="username" value="$username">
EOT

print "<center><table border=1><caption>Event Type Color Codes:</caption><tr>\n";
$num=0;
foreach $gig_type (@EVENT) {
        if ($num > 0 && $EVENT[$num] ne "") {
                print "<td><font color=\"#$COLORS[$num]\">$EVENT[$num]</td>\n";
        }
        $num++;
}
print "</tr></table></center><br>\n";

print <<EOT;
<center><input type="submit" name="calendarview" value="Show as Calendar View"></center>
<center><table border=1 width="1000">
<tr>
<td>&nbsp;</td>
<td width="250">Labor</td>
<td width="500">Date & Description</td>
<td>Time</td>
<td>Notes</td>
<td width="100">Attachments</td>
<td>&nbsp;</td>

EOT

while(@row = $DBI::result->fetchrow_array) {
	$ref++;
	$date=$row[0];
        &getlaborneeded;
        &getcurrentlabor;
                                                 
        $row[2] =~ s/\"/"/g;
        $row[2] =~ s/\'/'/g;
        $row[4] =~ s/\"/"/g;
        $row[4] =~ s/\'/'/g;
        $row[6] =~ s/\"/"/g;
        $row[6] =~ s/\'/'/g;
                                
        $color = "#$COLORS[$row[1]]";
                                        
        $peopleneeded = 0;
	%emptylabor=();
        foreach $key (sort keys %LABOR) {			## Calculate the empty labor slots needed
                $emptylabor{$key} = $LABORNEEDED{$key} - $CURRENTLABOR{$key};
                $peopleneeded = $peopleneeded + $emptylabor{$key};
        }

	$highlight = "#$COLORSETUP{'calendar background'}";
	$ds = "";
	foreach $key (@working) {		## Highlight the row if the employee is already signed up
		if ($key eq $employeenum) {
			$ds = 1;
			$highlight = "#$COLORSETUP{'labor full highlight'}";			
		}
	}

        $pendingwarn = "";
        if ($row[22] eq "1") {  ## If gig is marked as pending/tentative
                $highlight = "#FF0000";
                $pendingwarn = "<font color=white size=4>This event is tentative!</font><br>";
        }

	($thisdatesplit,$junk) = split(/\./,$row[0]);
        $wy = substr($row[0],2,2);
        $wm = substr($row[0],4,2);
        $wd = substr($row[0],6,2);
	
	$datestr = "$wy$wm$wd";
	$wday = `date -d $datestr +%w`;

	$files = $row[16];

	print "<tr><td bgcolor=\"$highlight\">\n";
	if ($active && $ds ne 1 && $row[5] eq "1") {
		if ($peopleneeded) {
			foreach $key (keys %emptylabor) {
				if ($emptylabor{$key} > 0 && $EMPLABOR[$employeenum][$key] eq "1") {
	                                if ($EMPLOYEEBYDATE{$thisdatesplit} eq "1") {
        	                                print "<table border=0 width=100%><tr><td bgcolor=red><input type=\"submit\" name=\"$row[0]-$key\" id=\"$row[0]-$key\" value=\"Signup as $LABOR{$key}\" OnClick=\"return confirmSubmit()\"></td></tr></table>\n";
                	                } else {
                        	                print "<table border=0 width=100%><tr><td bgcolor=green><input type=\"submit\" name=\"$row[0]-$key\" id=\"$row[0]-$key\" value=\"Signup as $LABOR{$key}\" OnClick=\"return confirmSign()\"></td></tr></table>\n";
					}	
				}
			}
		} else {
			print "<font color=\"#808080\">NO POSITIONS AVAILABLE</font>\n";
		}
	} else {
		print "<font> </font>\n";
	}

	print "</td><td bgcolor=\"$highlight\"><table border=0>\n";

        $laborneededhtml = "";

	foreach $key (reverse sort keys %LABORNEEDED) {
		$num=$LABORNEEDED{$key};
		while ($num >= 1) {
			$indexnum = (($LABORNEEDED{$key} - $num) +1);
			print "<tr><td><font color=\"$color\"><small>$LABOR{$key}:</small></font></td><td><font color=\"$color\"><small>$EMPLOYEES{$LABOR_NUM[$key][$indexnum]}</small></font></td></tr>\n";
			$num--;
		}
	}

	print "</table></td><td bgcolor=\"$highlight\">$pendingwarn<font color=\"$color\">$DAYS[$wday], $row[2]</font></td><td bgcolor=\"$highlight\"><font color=\"$color\">$row[6]&nbsp;</font></td>\n";
	if ($row[4] ne "") {
		$row[4] =~ s/\n/\\n/ig;
                $row[4] =~ s/\r//ig;
		print "<td bgcolor=\"$highlight\"><a href=\"employee.cgi\" ONMOUSEOVER=\"popup('<font color=black>$row[4]</font>','yellow')\"\; ONMOUSEOUT=\"kill()\">Notes</a></td>\n";
	} else {
		print "<td bgcolor=\"$highlight\"><font color=\"#808080\">No Notes</font></td>\n";
	}
	print "<td bgcolor=\"$highlight\" width=\"100\"><font size=\"1\"><small>$files</font></small></td>\n";
	print "<td bgcolor=\"$highlight\"><input type=\"submit\" name=\"$row[0]\" value=\"View\"></td></tr>\n";
}
}
print "</table><br><br>\n";
&credit;

sub getDatesByEmployee {
	$sth = $dbh->prepare("select * from `gig labor` WHERE `active`='1' AND `employee` = $employeenum");
	$sth->execute();  	

	while(@row2 = $sth->fetchrow_array) {
		($empdate,$junk) = split(/\./,$row2[0]);
		$EMPLOYEEBYDATE{$empdate} = 1;
		$EMPLOYEEBYGIG{$row2[0]} = 1;
	}
}

sub panic {
	print "Content-type:text/html\n\n";
	print "<center><font color=\"#$COLORSETUP{'error font'}\"><h2>ERROR</h2></font></center>\n";
	print "<center><font size=5 color=\"#$COLORSETUP{'error font'}\">$message</font></center>\n";
}

sub changeemail {

	if ($emailadd ne "" && ($emailadd =~ /[\~\`\!\#\$\%\^\&\*\(\)\+\=\{\[\}\]\|\\\:\;\"\'\<\>\/\?]/ || $emailadd !~ /@/ || $emailadd !~ /\./)) {
		print "<center><h2>Email Address is Invalid!</h2></center>\n";
	} else {
		$dbh->do("UPDATE `employees` SET `$email` = \"$emailadd\" WHERE `num` = \"$employeenum\"");
	}

}

sub changepasswd {

	if ($FORM{'newpassword'} eq "") {
		print "<center><h2>You did not enter a new password!</h2></center>\n";
		$skip = "1";
	} elsif ($FORM{'newpassword'} ne $FORM{'newpassword2'}) {
		print "<center><h2>Passwords do not match!</h2></center>\n";
		$skip = "1";
	} elsif ($FORM{'newpassword'} =~ /\s/ || $FORM{'newpassword'} =~ /\"/ || $FORM{'newpassword'} =~ /\'/) {
		print "<center><h2>Password contains invalid characters!</h2></center>\n";
		$skip = "1";
	}

	unless ($skip eq "1") {
			
		srand($$|time);
		@saltchars=(a..z,A..Z,0..9,'.','/');
		$salt=$saltchars[int(rand($#saltchars+1))];
		$salt.=$saltchars[int(rand($#saltchars+1))];
		$passwdcrypt = crypt($FORM{'newpassword'},$salt);
					
		open (HTPASSWD,".htpasswd");
		flock(HTPASSWD, 2);
		@HTPASSWD = <HTPASSWD>;
		close HTPASSWD;
		open (HTPASSWD,">.htpasswd");
		flock(HTPASSWD, 2);
		foreach $line (@HTPASSWD) {
			chop($line);
			($name,$passwd) = split(':', $line);
			if ($name eq $username) {
				print HTPASSWD "$name\:$passwdcrypt\n";
			} else {
				print HTPASSWD "$line\n";
			}
		}		
		close HTPASSWD;
		
		print "<center><h2>Password updated!</h2></center>\n";
	}
}

sub changes {

	$email = "email";
	$emailadd = $FORM{'email1'};
	&changeemail;

	$email = "email2";
	$emailadd = $FORM{'email2'};
	&changeemail;

	$dbh->do("UPDATE `employees` SET `notifyemail` = \"$FORM{'notifications'}\", `remindemail` = \"$FORM{'reminders'}\", `notifydays` = \"$FORM{'days'}\", `phone` = \"$FORM{'phone'}\" WHERE `num` = \"$employeenum\"");
}

sub sign {
	$DBI::result = $dbh->prepare("select * from `gig labor` WHERE `date` = \"$edit\"");
	$DBI::result->execute();

	while(@row = $DBI::result->fetchrow_array) {

		if ($row[2] eq $employeenum) {
			$message = "You are already signed up for this event!";
			&panic;
			exit;
		} 

##		} else {
##			$message = "You can not sign up for this, it is full";
##			&panic;
##			exit;
##		}
	}
	$dbh->do("INSERT INTO `gig labor` (`date`, `labor type`, `employee`) VALUES (\"$edit\", \"$type\", \"$employeenum\")");
}


$dbh->disconnect();
exit;

sub generateSignupButtons {
	$peopleneeded = 0;
	%emptylabor=();
	foreach $key (sort keys %LABOR) {                       ## Calculate the empty labor slots needed
		$emptylabor{$key} = $LABORNEEDED{$key} - $CURRENTLABOR{$key};  
		$peopleneeded = $peopleneeded + $emptylabor{$key};
	}

	($thisdatesplit,$junk) = split(/\./,$edit);	
        if ($active) {
                if ($peopleneeded) {
                        foreach $key (keys %emptylabor) {
                                if ($emptylabor{$key} > 0 && $EMPLABOR[$employeenum][$key] eq "1") {
                                       if ($EMPLOYEEBYDATE{$thisdatesplit} eq "1") {
        	                                $signupbuttons = $signupbuttons . "<table border=0><tr><td bgcolor=red><input type=\"submit\" name=\"$date-$key\" id=\"$date-$key\" value=\"Signup as $LABOR{$key}\" OnClick=\"return confirmSubmit()\"></td></tr></table>\n";
                                        } else {
                                                $signupbuttons = $signupbuttons .  "<table border=0><tr><td bgcolor=green><input type=\"submit\" name=\"$date-$key\" id=\"$date-$key\" value=\"Signup as $LABOR{$key}\" OnClick=\"return confirmSign()\"></td></tr></table>\n";
                                        }
                                }
                        }   
                }
        }
}

sub printjavawarn {
print <<EOT;
	<script LANGUAGE="JavaScript">
	<!--
	function confirmSubmit()
	{
	var agree=confirm("You are already signed up for an event on this date, Are you sure you want to sign up?");
	if (agree)
        	return true ;
	else
        	return false ;
	}

        function confirmSign()
        {                       
        var agree=confirm("$SETUP{'Signup Confirm Message'}");
        if (agree)                              
                return true ;           
        else                                    
                return false ;           
        }                        

	// -->
	</script>
EOT
}

sub credit {
        print "<br><br><center><a href=\"http://nason.com\">Schedule'N Event Management 2.3 &copy;2008 Nason Tackett</a></center>\n";
}

sub settings {

$DBI::result = $dbh->prepare("select * from `employees` WHERE `username` = \"$username\"");
$DBI::result->execute();

while(@row = $DBI::result->fetchrow_array) {

	$email1 = $row[4];
	$email2 = $row[5];
	$remindemail = $row[8];
	$notifyemail = $row[7];
	$notifydays = $row[6];
	$phone = $row[14];
}

&getemployeelabortypes;
&getemployee;
                
$selecteda{$remindemail} = "Selected";
$selectedb{$notifyemail} = "Selected";
$selectedc{$notifydays} = "Selected";

print <<EOT;
<body>
<form name="top" action="employee.cgi" method="post">
<input type="hidden" name="username" value="$username">
<center><table borderColor="#$COLORSETUP{'table bordercolor'}" bgColor="#$COLORSETUP{'table background'}" border="1" width="700">
    <tr>
        <td>
	   <center><font face="Courier New" size="4">Account Settings</font>
	</td>
    </tr>
      <tr>
        <td>
	Phone: <input size="15" name="phone" value="$phone">
	<br>
	Email 1: <input size="30" name="email1" value="$email1">
	<br>
	Email 2: <input size="30" name="email2" value="$email2">
	<br>
	Send upcoming event reminders to: <select size="1" name="reminders">
            <option $selecteda{'1'} value="1">Email 1</option>
            <option $selecteda{'2'} value="2">Email 2</option>
          </select><br>
          Send new event &amp; event cancellation notifications to:<select size="1" name="notifications">
            <option $selectedb{'1'} value="1">Email 1</option>
            <option $selectedb{'2'} value="2">Email 2</option>
          </select>
          <p>Send new event notifications for events that are within <select size="1" name="days">
            <option value="0" $selectedc{'0'}>No Limit Set</option>
            <option value="7" $selectedc{'7'}>1 Week</option>
            <option value="14" $selectedc{'14'}>2 Weeks</option>
            <option value="31" $selectedc{'31'}>1 Month</option>
            <option value="62" $selectedc{'62'}>2 Months</option>
            <option value="182" $selectedc{'182'}>6 months</option>
            <option value="365" $selectedc{'365'}>1 Year</option>
            <option value="-1" $selectedc{'-1'}>No Notification</option>
          </select></p>
          <p><input type="submit" value="Submit Changes" name="change">
	<br>
        </td>
      </tr></table>
<br>
<table borderColor="#$COLORSETUP{'table bordercolor'}" bgColor="#$COLORSETUP{'table background'}" border="1" width="700">
    <tr>
        <td>
	   <center><font face="Courier New" size="4">Change Password</font>
	</td>
    </tr>
      <tr><td>
	<br>
<center>
New password: <input type="password" size="30" name="newpassword">&nbsp;Retype password: <input type="password" size="30" name="newpassword2"><br>
<input type="submit" value="Change Password" name="changepasswd">
</center>
    </td></tr>
</table>
<br>

<table borderColor="#$COLORSETUP{'table bordercolor'}" bgColor="#$COLORSETUP{'table background'}" border="1" width="400">
    <tr>
        <td>
	   <center><font face="Courier New" size="4">Your Qualifications</font>
	</td>
    </tr>
    <tr>
	<td width="100%">	

EOT
        foreach $key (reverse sort keys %LABOR) {
		if ($EMPLABOR[$employeenum][$key] eq "1") {
			$selected="checked";
		} else {
			$selected="";
		}
		print "<input type=\"radio\" value=\"1\" name=\"$key\" $selected>$LABOR{$key}<br>\n";
        }
	if ($isAdmin eq "1") {
		$selected="checked";
		$logonasadmin = "<a href=\"http://$SETUP{'Domain Name'}/cgi-bin/edit/edit.cgi\">Login as an Administrator</a>";
	} else {
		$selected="";
	}
	print "<br><input type=\"checkbox\" value=\"1\" name=\"$key\" $selected> Administrator<br>$logonasadmin\n"; 

print <<EOT;  
      </td>
    </tr>
  </table>
</center>
	<br><br>
EOT
}


sub directory {

print "<FORM METHOD=\"POST\" name=\"toolbar\" ACTION=\"employee.cgi\">\n";
print "<input type=\"hidden\" name=\"username\" value=\"$username\">\n";

print <<EOT;
<center>
<table borderColor="#$COLORSETUP{'table bordercolor'}" bgColor="#$COLORSETUP{'table background'}" border="1">
  <tbody>
    <tr>
      <td height="19" colspan="5"><b>Client Contact Info</b></td>
    </tr>
            <tr>
              <td>Name</td>
              <td>Contact</td>
              <td>Phone</td>
              <td>Email</td>
            </tr>
EOT
        $DBI::result = $dbh->prepare("select * from `clients` ORDER BY `name` ASC");
        $DBI::result->execute();
        while(@row = $DBI::result->fetchrow_array) {
                print "<tr>\n";
                print "<td>$row[1]</td>\n";
                print "<td>$row[5]</td>\n";
                print "<td>$row[4]</td>\n";
                print "<td><a href=\"mailto:$row[3]\">$row[3]</a></td>\n";
                print "</tr>\n";                                
        }
        $dbh->disconnect();

print <<EOT;
  </tbody>
</table>
</center><br><br>
   
EOT

if ($FORM{'showinactivedirectory'}) {
	print "<center><input type=\"submit\" name=\"directory\" value=\"Show Active Employees Only\"></center><br>\n";
	$showonlyactive = "";
} else {
	print "<center><input type=\"submit\" name=\"showinactivedirectory\" value=\"Show Active & Inactive Employees\"></center><br>\n";
	$showonlyactive = "WHERE `active` = '1'";
}

print <<EOT;
<center>
<table borderColor="#$COLORSETUP{'table bordercolor'}" bgColor="#$COLORSETUP{'table background'}" border="1">
  <tbody>
    <tr>
      <td height="19" colspan="6"><b>Employee Contact Info</b></td>
    </tr>
            <tr>
              <td>Name</td>
              <td>Phone</td>
              <td>Email 1</td>
              <td>Email 2</td>
            </tr>
EOT
        $DBI::result = $dbh->prepare("select * from `employees` $showonlyactive ORDER BY `employee` ASC");
        $DBI::result->execute();
        while(@row = $DBI::result->fetchrow_array) {
		if ($row[2] eq "1") {
			$myfontcolor = $COLORSETUP{'default font'};
		} else {
			$myfontcolor = $COLORSETUP{'error font'}; 
		}
        
                print "<tr>\n";
                print "<td><font color=\"#$myfontcolor\">$row[1]</font></td>\n";
                print "<td><font color=\"#$myfontcolor\">$row[14]</font></td>\n";
                print "<td><a href=\"mailto:$row[4]\">$row[4]</a></td>\n";
                print "<td><a href=\"mailto:$row[5]\">$row[5]</a></td>\n";
                print "</tr>\n";                                
        }
        $dbh->disconnect();

print <<EOT;
  </tbody>
</table>
</center>
   
EOT

}
